;-----------------------------------------------------------------------
; DateiName        :  wooble.asm
;-----------------------------------------------------------------------
; Author           :  Christian Rsch
;
; Erstellungsdatum :  06.10.2001
;-----------------------------------------------------------------------
; Info : taken this from a plasma-FX and changed it a bit *g*
;-----------------------------------------------------------------------


;I added this rastertiming...
RTIME           equ     0               ; 1=show rastertiming
                                        ; 0=do not show rastertiming
;make sure u can see the border!


ideal
p386n


assume cs:main_code,ds:main_code


segment main_code
org 100h

main:
                mov     al,13h          ;switching to Mode 13h (VGA 320x200x256)
                int     10h

                push    0a000h          ;VGA-Segment
                pop     es

                mov     dx,3c8h         ;prepare Palette
                xor     al,al
                xor     cl,cl
                out     dx,al
                inc     dx
@@palette1:
                mov     al,cl
                call    putsix
                inc     cl
                cmp     cl,64
                jnz     @@palette1
                dec     cl
@@palette2:
                mov     al,cl
                call    putsix
                dec     cl
                jnz     @@palette2
                call    putsix

                xor     cx,cx
                xor     ax,ax

@@mainloop:
IF RTIME
                mov     dx,3dah
                in      al,dx
                mov     dx,3c0h
                mov     al,31h
                out     dx,al
                mov     al,00h          ;use color 00h for border
                out     dx,al
ENDIF

                mov     dx,3dah
                in      al,dx
                test    al,8            ;waiting for V-Retrace
                jz      $-3             ;nice way 2 make a loop ;)
                xor     di,di


IF RTIME
                mov     dx,3dah
                in      al,dx
                mov     dx,3c0h
                mov     al,31h
                out     dx,al
                mov     al,80h          ;use color 80h for border
                out     dx,al
ENDIF


                xor     ax,ax
                mov     cl,199
@@vertloop:
                mov     dx,320
@@horloop:
                mov     si,bp
                shl     si,2
                add     si,dx
                and     si,255
                mov     al,[sintab+si]
                shr     al,1

                mov     si,ax
                add     si,cx
                and     si,255
                mov     al,[sintab+si]

                add     al,dl

                stosb                   ;output color

                dec     dx
                jnz     @@horloop

                loop    @@vertloop


                inc     bp
                and     bp,255

                in      al,60h
                cmp     al,1
                jnz     @@mainloop
@@theend:
                mov     al,3
                int     10h
;                jmp     cs:0
                int     20h

putsix:                                 ;pushes two greycolors 2 palette
                out     dx,al
                out     dx,al
                out     dx,al
                out     dx,al
                out     dx,al
                out     dx,al
                ret

  label         sintab byte

include "sinus.asm"



  ends main_code
end main

;-----
; EOF
;-----
